package immibis.ars.beams;

import forge.ICraftingHandler;
import forge.MinecraftForge;
import ic2.api.Items;
import immibis.ars.Functions;
import immibis.ars.mod_AdvancedRepulsionSystems;
import immibis.core.api.porting.SidedProxy;
import immibis.core.aspects.ClientOnly;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import net.minecraft.server.Block;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.IInventory;
import net.minecraft.server.Item;
import net.minecraft.server.ItemStack;
import net.minecraft.server.ModLoader;

public class BeamsMain
{
    public static BlockBeam blockBeam;
    public static BlockBeamStuff blockBeamMachines;
    public static ItemLogicCard itemLogicCard;

    public static void init()
    {
        ModLoader.registerTileEntity(TileUpgradeUnit.class, "AdvRepSys TileUpgradeUnit");
        ModLoader.registerTileEntity(TileTeslaCoil.class, "AdvRepSys TileTeslaCoil");
        ModLoader.registerTileEntity(TileUpgradeCombiner.class, "AdvRepSys UpgradeCombiner");
        ModLoader.registerTileEntity(TileRangeUpgrade.class, "AdvRepSys RangeUpgrade");
        ModLoader.registerTileEntity(TileEMPUpgrade.class, "AdvRepSys EMPUpgrade");
        ModLoader.registerTileEntity(TileSpeedUpgrade.class, "AdvRepSys SpeedUpgrade");
        ModLoader.registerTileEntity(TileLootCollector.class, "AdvRepSys LootCollector");
        ModLoader.registerTileEntity(TileFieldFilter.class, "AdvRepSys FieldFilter");
        ModLoader.registerTileEntity(TileInventoryContentsFilter.class, "AdvRepSys InventoryContentsFilter");
        ModLoader.registerTileEntity(TilePotionUpgrade.class, "AdvRepSys PotionUpgrade");
        ModLoader.registerTileEntity(TileSuppressorUpgrade.class, "AdvRepSys SuppressorUpgrade");
        SidedProxy.instance.preloadTexture("/immibis/ars/beams/world.png");
        SidedProxy.instance.addLocalization("death.ARSteslacoil", "was zapped");
        itemLogicCard = new ItemLogicCard(Functions.getItemIdFor("itemLogicCard", 11120));
        blockBeam = new BlockBeam(Functions.getBlockIdFor("beam", 627));
        blockBeamMachines = new BlockBeamStuff(Functions.getBlockIdFor("teslaMachines", 628));

        try
        {
            Method var0 = BeamsMain.class.getDeclaredMethod("initClient", new Class[0]);
            var0.invoke((Object)null, new Object[0]);
        }
        catch (NoSuchMethodException var14)
        {
            ;
        }
        catch (IllegalAccessException var15)
        {
            throw new RuntimeException(var15);
        }
        catch (InvocationTargetException var16)
        {
            throw new RuntimeException(var16);
        }

        ItemStack var17 = new ItemStack(blockBeamMachines, 1, 0);
        ItemStack var1 = new ItemStack(blockBeamMachines, 1, 1);
        ItemStack var2 = new ItemStack(blockBeamMachines, 1, 2);
        ItemStack var3 = new ItemStack(blockBeamMachines, 1, 3);
        ItemStack var4 = new ItemStack(blockBeamMachines, 1, 4);
        ItemStack var5 = new ItemStack(blockBeamMachines, 1, 5);
        ItemStack var6 = new ItemStack(blockBeamMachines, 1, 6);
        ItemStack var7 = new ItemStack(blockBeamMachines, 1, 7);
        ItemStack var8 = new ItemStack(blockBeamMachines, 1, 8);
        ItemStack var9 = new ItemStack(blockBeamMachines, 1, 9);
        ItemStack var10 = new ItemStack(blockBeamMachines, 1, 10);
        ItemStack var11 = new ItemStack(mod_AdvancedRepulsionSystems.itemComponent, 1, 0);
        ItemStack var12 = Items.getItem("refinedIronIngot");
        ModLoader.addRecipe(var1, new Object[] {" # ", " | ", "-H-", '#', Block.IRON_BLOCK, '|', Item.IRON_INGOT, 'H', Items.getItem("hvTransformer"), '-', Items.getItem("glassFiberCableItem")});
        ModLoader.addRecipe(copyStackWithCount(var17, 4), new Object[] {"I^I", ".M.", "C.C", 'M', Items.getItem("machine"), 'C', Items.getItem("electronicCircuit"), 'I', var12, '.', Block.GLASS, '^', Block.REDSTONE_TORCH_ON});
        ModLoader.addRecipe(copyStackWithCount(var2, 4), new Object[] {"G^G", ".M.", "G.G", 'G', Item.GOLD_INGOT, 'M', Items.getItem("machine"), '^', Block.REDSTONE_TORCH_ON, '.', Block.GLASS});
        ModLoader.addRecipe(var3, new Object[] {"I^I", "CMC", "CCC", 'I', var12, 'C', Items.getItem("copperCableItem"), '^', Block.REDSTONE_TORCH_ON, 'M', Items.getItem("machine")});
        ModLoader.addRecipe(var4, new Object[] {"I^I", "CTC", "OCO", 'I', var12, '^', Block.REDSTONE_TORCH_ON, 'T', Items.getItem("mvTransformer"), 'O', Item.ENDER_PEARL, 'C', Items.getItem("glassFiberCableItem")});
        ModLoader.addRecipe(var5, new Object[] {"I^I", "SMS", "SSS", 'I', var12, '^', Block.REDSTONE_TORCH_ON, 'M', Items.getItem("machine"), 'S', Item.SUGAR});
        ModLoader.addRecipe(var6, new Object[] {"I^I", "OMO", "OOO", 'I', var12, '^', Block.REDSTONE_TORCH_ON, 'M', Items.getItem("machine"), 'O', Item.EYE_OF_ENDER});
        ModLoader.addRecipe(var10, new Object[] {"I^I", "OMO", "BOB", 'I', var12, '^', Block.REDSTONE_TORCH_ON, 'O', Item.EYE_OF_ENDER, 'M', Items.getItem("machine"), 'B', Item.GLASS_BOTTLE});
        ModLoader.addRecipe(var9, new Object[] {"I^I", "IMI", "ICI", 'I', var12, '^', Block.REDSTONE_TORCH_ON, 'M', Items.getItem("machine"), 'C', Items.getItem("advancedCircuit")});
        ModLoader.addShapelessRecipe(var7, new Object[] {var17, var11});
        ModLoader.addShapelessRecipe(var8, new Object[] {var17, Item.ENDER_PEARL});
        ItemStack var13 = new ItemStack(itemLogicCard, 1, 4);
        ModLoader.addRecipe(copyStackWithCount(var13, 16), new Object[] {" P ", "PRP", " P ", 'P', Item.PAPER, 'R', Item.REDSTONE});
        ModLoader.addShapelessRecipe(new ItemStack(itemLogicCard, 1, 0), new Object[] {var13, Item.APPLE});
        ModLoader.addShapelessRecipe(new ItemStack(itemLogicCard, 1, 5), new Object[] {var13, Item.SUGAR});
        ModLoader.addShapelessRecipe(new ItemStack(itemLogicCard, 1, 6), new Object[] {var13, Item.REDSTONE});
        ModLoader.addShapelessRecipe(new ItemStack(itemLogicCard, 1, 7), new Object[] {var13, Item.PORK});
        ModLoader.addShapelessRecipe(new ItemStack(itemLogicCard, 1, 8), new Object[] {var13, Item.ROTTEN_FLESH});
        ModLoader.addShapelessRecipe(new ItemStack(itemLogicCard, 1, 9), new Object[] {var13, Item.IRON_INGOT});
        ModLoader.addRecipe(new ItemStack(itemLogicCard, 1, 1), new Object[] {"!!!", "!C!", "! !", 'C', var13, '!', Item.REDSTONE});
        ModLoader.addRecipe(new ItemStack(itemLogicCard, 1, 2), new Object[] {"! !", "!C!", "!!!", 'C', var13, '!', Item.REDSTONE});
        ModLoader.addRecipe(new ItemStack(itemLogicCard, 1, 3), new Object[] {"!!!", " C ", 'C', var13, '!', Item.REDSTONE});
        ModLoader.addRecipe(var13, new Object[] {"#", '#', new ItemStack(itemLogicCard, 1, -1)});
        MinecraftForge.registerCraftingHandler(new ICraftingHandler()
        {
            public void onTakenFromCrafting(EntityHuman var1, ItemStack var2, IInventory var3)
            {
                if (var2.getItem() == BeamsMain.itemLogicCard && var2.getData() != 4)
                {
                    for (int var4 = 0; var4 < var3.getSize(); ++var4)
                    {
                        ItemStack var5 = var3.getItem(var4);

                        if (var5 != null && var5.getItem() != BeamsMain.itemLogicCard)
                        {
                            ++var5.count;
                        }
                    }
                }
            }
        });
    }

    private static ItemStack copyStackWithCount(ItemStack var0, int var1)
    {
        var0 = var0.cloneItemStack();
        var0.count = var1;
        return var0;
    }

    @ClientOnly
    public static void initClient() {}
}
