package immibis.ars.beams;

import ic2.api.Direction;
import ic2.api.EnergyNet;
import ic2.api.IEnergySink;
import net.minecraft.server.NBTTagCompound;
import net.minecraft.server.TileEntity;

public class TileEMPUpgrade extends TileBeamEmitter implements IEnergySink
{
    public static final int MAX_STORAGE = 1000000;
    public int storage;
    private boolean added_to_enet;
    private UpgradeData upg_data = new UpgradeData();

    public TileEMPUpgrade()
    {
        this.upg_data.emp = this;
    }

    /**
     * Reads a tile entity from NBT.
     */
    public void a(NBTTagCompound var1)
    {
        super.a(var1);
        this.storage = var1.getInt("eu");
    }

    /**
     * Writes a tile entity to NBT.
     */
    public void b(NBTTagCompound var1)
    {
        super.b(var1);
        var1.setInt("eu", this.storage);
    }

    /**
     * invalidates a tile entity
     */
    public void j()
    {
        if (this.added_to_enet)
        {
            EnergyNet.getForWorld(this.world).removeTileEntity(this);
            this.added_to_enet = false;
        }

        super.j();
    }

    public Object getOutput()
    {
        return this.upg_data;
    }

    /**
     * Allows the entity to update its state. Overridden in most subclasses, e.g. the mob spawner uses this to count
     * ticks and creates a new spawn inside its implementation.
     */
    public void q_()
    {
        if (!this.world.isStatic)
        {
            if (!this.added_to_enet)
            {
                EnergyNet.getForWorld(this.world).addTileEntity(this);
                this.added_to_enet = true;
            }
        }
    }

    public boolean acceptsEnergyFrom(TileEntity var1, Direction var2)
    {
        return true;
    }

    public boolean isAddedToEnergyNet()
    {
        return this.added_to_enet;
    }

    public boolean demandsEnergy()
    {
        return this.storage < 1000000;
    }

    public int injectEnergy(Direction var1, int var2)
    {
        if (this.storage >= 1000000)
        {
            return var2;
        }
        else
        {
            this.storage += var2;
            return 0;
        }
    }

    public int getBeamColour()
    {
        return 1;
    }
}
