package immibis.ars.beams;

import immibis.ars.projectors.FFShape;
import immibis.ars.projectors.TileProjector;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import net.minecraft.server.Entity;
import net.minecraft.server.TileEntity;

public class TileFieldFilter extends TileBeamEmitter
{
    private int ticksToFieldCheck = 0;
    private TileProjector projector;
    private EntityFilter filter = new EntityFilter()
    {
        public Set filter(Set var1)
        {
            FFShape var2 = TileFieldFilter.this.projector.getShape();

            if (var2 == null)
            {
                var1.clear();
                return var1;
            }
            else
            {
                HashSet var3 = new HashSet();
                Iterator var5 = var1.iterator();

                while (var5.hasNext())
                {
                    Entity var4 = (Entity)var5.next();

                    if (var2.getBlockMode((int)Math.floor(var4.locX), (int)Math.floor(var4.locY), (int)Math.floor(var4.locZ)) != 0)
                    {
                        var3.add(var4);
                    }
                }

                return var3;
            }
        }
    };

    /**
     * Allows the entity to update its state. Overridden in most subclasses, e.g. the mob spawner uses this to count
     * ticks and creates a new spawn inside its implementation.
     */
    public void q_()
    {
        super.q_();

        if (!this.world.isStatic)
        {
            if (this.ticksToFieldCheck <= 0)
            {
                this.checkForField();
                this.ticksToFieldCheck = 20;
            }

            --this.ticksToFieldCheck;
        }
    }

    public Object getOutput()
    {
        return this.filter;
    }

    private void checkForField()
    {
        this.projector = null;

        for (int var1 = -1; var1 <= 1; ++var1)
        {
            for (int var2 = -1; var2 <= 1; ++var2)
            {
                for (int var3 = -1; var3 <= 1; ++var3)
                {
                    TileEntity var4 = this.world.getTileEntity(this.x + var1, this.y + var2, this.z + var3);

                    if (var4 instanceof TileProjector)
                    {
                        this.projector = (TileProjector)var4;
                        return;
                    }
                }
            }
        }
    }

    public int getBeamColour()
    {
        return 1;
    }
}
