package immibis.ars.beams;

import immibis.ars.mod_AdvancedRepulsionSystems;
import immibis.core.BasicInventory;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import net.minecraft.server.Entity;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.IInventory;
import net.minecraft.server.ItemStack;

public class TileInventoryContentsFilter extends TileBeamEmitter implements IInventory
{
    private BasicInventory inv = new BasicInventory(1);
    private EntityFilter filter = new EntityFilter()
    {
        public Set filter(Set var1)
        {
            if (TileInventoryContentsFilter.this.inv.contents[0] == null)
            {
                var1.clear();
                return var1;
            }
            else
            {
                HashSet var2 = new HashSet();
                Iterator var4 = var1.iterator();

                while (var4.hasNext())
                {
                    Entity var3 = (Entity)var4.next();

                    if (var3 instanceof EntityHuman)
                    {
                        ItemStack[] var8 = ((EntityHuman)var3).inventory.items;
                        int var7 = ((EntityHuman)var3).inventory.items.length;

                        for (int var6 = 0; var6 < var7; ++var6)
                        {
                            ItemStack var5 = var8[var6];

                            if (mod_AdvancedRepulsionSystems.areItemsEqual(var5, TileInventoryContentsFilter.this.inv.contents[0]))
                            {
                                var2.add(var3);
                                break;
                            }
                        }
                    }
                }

                return var2;
            }
        }
    };

    public Object getOutput()
    {
        return this.filter;
    }

    /**
     * Returns the number of slots in the inventory.
     */
    public int getSize()
    {
        return this.inv.contents.length;
    }

    /**
     * Returns the stack in slot i
     */
    public ItemStack getItem(int var1)
    {
        return this.inv.contents[var1];
    }

    /**
     * Decrease the size of the stack in slot (first int arg) by the amount of the second int arg. Returns the new
     * stack.
     */
    public ItemStack splitStack(int var1, int var2)
    {
        return this.inv.splitStack(var1, var2);
    }

    /**
     * When some containers are closed they call this on each slot, then drop whatever it returns as an EntityItem -
     * like when you close a workbench GUI.
     */
    public ItemStack splitWithoutUpdate(int var1)
    {
        return null;
    }

    /**
     * Sets the given item stack to the specified slot in the inventory (can be crafting or armor sections).
     */
    public void setItem(int var1, ItemStack var2)
    {
        this.inv.contents[var1] = var2;
    }

    /**
     * Returns the name of the inventory.
     */
    public String getName()
    {
        return "Loot collector";
    }

    /**
     * Returns the maximum stack size for a inventory slot. Seems to always be 64, possibly will be extended. *Isn't
     * this more of a set than a get?*
     */
    public int getMaxStackSize()
    {
        return 64;
    }

    /**
     * Do not make give this method the name canInteractWith because it clashes with Container
     */
    public boolean a(EntityHuman var1)
    {
        return var1.e((double)this.x + 0.5D, (double)this.y + 0.5D, (double)this.z + 0.5D) <= 64.0D;
    }

    public void f() {}

    public void g() {}

    public boolean onBlockActivated(EntityHuman var1)
    {
        if (!this.world.isStatic)
        {
            var1.openGui(mod_AdvancedRepulsionSystems.instance, 15, this.world, this.x, this.y, this.z);
        }

        return true;
    }

    public int getBeamColour()
    {
        return 1;
    }

	@Override public ItemStack[] getContents() {return inv.contents;}
	@Override public void setMaxStackSize(int arg0) {}
}
