package immibis.ars.beams;

import immibis.ars.mod_AdvancedRepulsionSystems;
import immibis.core.BasicInventory;
import immibis.core.porting.IPortableSidedInventory;
import java.util.Arrays;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.EntityItem;
import net.minecraft.server.IInventory;
import net.minecraft.server.ItemStack;
import net.minecraft.server.NBTTagCompound;

public class TileLootCollector extends TileBeamEmitter implements IInventory, IPortableSidedInventory
{
    private UpgradeData upgrade = new UpgradeData();
    private BasicInventory inv = new BasicInventory(10);
    public static final int SLOT_FILTER = 0;
    public static final int SLOT_INV = 1;

    public TileLootCollector()
    {
        this.upgrade.lootCollectors = Arrays.asList(new TileLootCollector[] {this});
    }

    public boolean onBlockActivated(EntityHuman var1)
    {
        if (!this.world.isStatic)
        {
            var1.openGui(mod_AdvancedRepulsionSystems.instance, 14, this.world, this.x, this.y, this.z);
        }

        return true;
    }

    /**
     * Writes a tile entity to NBT.
     */
    public void b(NBTTagCompound var1)
    {
        super.b(var1);
        var1.set("inv", this.inv.writeToNBT());
    }

    /**
     * Reads a tile entity from NBT.
     */
    public void a(NBTTagCompound var1)
    {
        super.a(var1);
        this.inv.readFromNBT(var1.getList("inv"));
    }

    public Object getOutput()
    {
        return this.upgrade;
    }

    public int getBeamColour()
    {
        return 1;
    }

    public boolean collectItem(EntityItem var1)
    {
        if (!mod_AdvancedRepulsionSystems.areItemsEqual(var1.itemStack, this.inv.contents[0]))
        {
            return false;
        }
        else
        {
            for (int var2 = 0; var2 < 9; ++var2)
            {
                int var3 = 1 + var2;
                ItemStack var4 = this.inv.contents[var3];

                if (var4 == null)
                {
                    this.inv.contents[var3] = var1.itemStack.cloneItemStack();
                    var1.itemStack.count = 0;
                    return true;
                }

                if (mod_AdvancedRepulsionSystems.areItemsEqual(var1.itemStack, var4))
                {
                    int var5 = var1.itemStack.getMaxStackSize();
                    int var6 = Math.min(var5 - var4.count, var1.itemStack.count);
                    var1.itemStack.count -= var6;
                    var4.count += var6;

                    if (var1.itemStack.count == 0)
                    {
                        return true;
                    }
                }
            }

            return false;
        }
    }

    /**
     * Returns the number of slots in the inventory.
     */
    public int getSize()
    {
        return this.inv.contents.length;
    }

    /**
     * Returns the stack in slot i
     */
    public ItemStack getItem(int var1)
    {
        return this.inv.contents[var1];
    }

    /**
     * Decrease the size of the stack in slot (first int arg) by the amount of the second int arg. Returns the new
     * stack.
     */
    public ItemStack splitStack(int var1, int var2)
    {
        return this.inv.splitStack(var1, var2);
    }

    /**
     * When some containers are closed they call this on each slot, then drop whatever it returns as an EntityItem -
     * like when you close a workbench GUI.
     */
    public ItemStack splitWithoutUpdate(int var1)
    {
        return null;
    }

    /**
     * Sets the given item stack to the specified slot in the inventory (can be crafting or armor sections).
     */
    public void setItem(int var1, ItemStack var2)
    {
        this.inv.contents[var1] = var2;
    }

    /**
     * Returns the name of the inventory.
     */
    public String getName()
    {
        return "Loot collector";
    }

    /**
     * Returns the maximum stack size for a inventory slot. Seems to always be 64, possibly will be extended. *Isn't
     * this more of a set than a get?*
     */
    public int getMaxStackSize()
    {
        return 64;
    }

    /**
     * Do not make give this method the name canInteractWith because it clashes with Container
     */
    public boolean a(EntityHuman var1)
    {
        return var1.e((double)this.x + 0.5D, (double)this.y + 0.5D, (double)this.z + 0.5D) <= 64.0D;
    }

    public void f() {}

    public void g() {}

    public int getStartInventorySide(int var1)
    {
        return 1;
    }

    public int getSizeInventorySide(int var1)
    {
        return 9;
    }
    
    @Override public ItemStack[] getContents() {return inv.contents;}
	@Override public void setMaxStackSize(int arg0) {}
}
